//-----------------------------------------------------------------------
//
//	LAB4 : FALL '03
//
// This file will instantiate your lock
//
// Build the edge-detection circuits for the rst_pin signal and the enter_pin signal here.
// Create a module called lock (it is instantiated in this module)
// The lock module will contain the FSM and the compare module.
// This module is to be instantiated in FPGA_top.v which will be synthesized and 
// implemented in the target FPGA.
//
//-----------------------------------------------------------------------
module LockTop(	Clock,
		ResetPin,
		EnterPin,
		Code,
		StatePin,
		Seg1, Seg2, Seg3, Seg4, Seg5, Seg6, Seg7, Seg8);

	//---------------------------------------------------------------
	// Declare all ports here
	//---------------------------------------------------------------
	input		Clock;
	input		ResetPin;
	input		EnterPin;
	input	[1:0]	Code;
	output	[2:0]	StatePin;
	output	[6:0]	Seg1, Seg2, Seg3, Seg4, Seg5, Seg6, Seg7, Seg8;
	reg	[6:0]	Seg1, Seg2, Seg3, Seg4, Seg5, Seg6, Seg7, Seg8;
	//---------------------------------------------------------------

	//---------------------------------------------------------------
	// Declare all wires and regs here
	//---------------------------------------------------------------
	wire		OutA;	// This is mapped to your openlock output from your FSM
	wire		OutB;	// This is mapped to your error output from your FSM
	reg		Enter;	// This is the output of your edge detector circuit
	reg		Reset;	// This is the output of your edge detector circuit
	//---------------------------------------------------------------

	//---------------------------------------------------------------
	// Put your edge detector circuit here.
	// You may add signals inside this block as you need them
	// Use ResetPin and EnterPin as your inputs
	// and Reset and Enter as your outputs
	// Notice that Reset and Enter are declared as 'reg' you may need to make them wires
	//---------------------------------------------------------------

	// Verilog goes here

	//---------------------------------------------------------------


	//---------------------------------------------------------------
	// Translate outputs to 7-Segment display
	//---------------------------------------------------------------
	always @ (OutA or OutB)
		if (OutA & ~OutB) begin
			Seg1 <= 7'b0111111;
			Seg2 <= 7'b1110011;
			Seg3 <= 7'b1111011;
			Seg4 <= 7'b0110111;
			Seg5 <= 7'b0000000;
			Seg6 <= 7'b0000000;
			Seg7 <= 7'b0000000;
			Seg8 <= 7'b0000000;
		end
		else if (~OutA & OutB) begin
			Seg1 <= 7'b1111011;
			Seg2 <= 7'b0110001;
			Seg3 <= 7'b0110001;
			Seg4 <= 7'b0111111;
			Seg5 <= 7'b0110001;
			Seg6 <= 7'b0000000;
			Seg7 <= 7'b0000000;
			Seg8 <= 7'b0000000;
		end
		else begin
			Seg1 <= 7'b0000000;
			Seg2 <= 7'b0000000;
			Seg3 <= 7'b0000000;
			Seg4 <= 7'b0000000;
			Seg5 <= 7'b0000000;
			Seg6 <= 7'b0000000;
			Seg7 <= 7'b0000000;
			Seg8 <= 7'b0000000;
		end
	//---------------------------------------------------------------

	//---------------------------------------------------------------
	// This is the instantiation of the Lock module which contains the FSM 
	//---------------------------------------------------------------
	Lock	ALock(	.Reset(Reset), 
			.Enter(Enter), 
			.Code(Code), 
			.Clock(Clock), 
			.Open(OutA), 
			.Error(outB),
			.State(StatePin));
	//---------------------------------------------------------------
endmodule



